Public  Post
Private sf



' Public members
Sub OnStartPage(ASP)
    Init(ASP.Request)
End Sub
Sub OnEndPage
    Set Post = Nothing
    Set sf = Nothing
End Sub
Sub Init(Request)
    Set Post = Context.CreateObject("VarDictionary")
    Post.itemsAssignmentAllowed = True
    Post.firstItemAsRoot = True
    Post.Missing = Empty
    If Request.TotalBytes = 0 Then
        ' Empty
        Exit Sub
    End If
    Set sf = Context.CreateObject("SFMain")
    Dim postStream
    Set postStream = sf.CreateMemoryStream
    postStream.unicodeText = False
    postStream.WriteBin Request.BinaryRead(Request.TotalBytes)
    postStream.Pos = 0
    BuildUploadRequest postStream
    Set postStream = Nothing
End Sub
Sub InitFromData(BinData)
    Set Post = Context.CreateObject("VarDictionary")
    Post.itemsAssignmentAllowed = True
    Post.firstItemAsRoot = True
    Post.Missing = Empty
    Set sf = Context.CreateObject("SFMain")
    Dim postStream
    Set postStream = sf.CreateMemoryStream
    postStream.unicodeText = False
    postStream.WriteBin BinData
    postStream.Pos = 0
    BuildUploadRequest postStream
    Set postStream = Nothing
End Sub
Sub Close()
    Set Post = Nothing
End Sub
Function GetPost
    If IsEmpty(Post) Then
        Err.Raise 2,"CUpload", "The Object has not been initialized. Call Init first."
    Else
        Set GetPost = Post
    End If
End Function

Private Function MaxNum(a,b)
    If a >= b Then MaxNum = a Else MaxNum = b
End Function
Private Function FindColonThroughQuotes(str,beg)
    Dim qPos, cPos
    Dim pos, qOpened
    
    pos = beg
    qOpened = False

    Do
        If qOpened Then
            qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
            If qPos = 0 Then
                ' In fact this is an error but we will ignore it anyway
                ' If you want to be more prcise put here an error raising code
                FindColonThroughQuotes = Len(str) + 1
                Exit Function
            Else
                pos = qPos + 1
                qOpened = False
            End If
        Else
            qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
            cPos = InStr(pos,str,";")
            If qPos = 0 Then
                If cPos > 0 Then
                    FindColonThroughQuotes = cPos
                Else
                    FindColonThroughQuotes = Len(str) + 1
                End If
                Exit Function
            End If
            If cPos <= qPos Then
                If cPos > 0 Then
                    FindColonThroughQuotes = cPos
                Else
                    FindColonThroughQuotes = Len(str) + 1
                End If
                Exit Function
            End If
            
            qOpened = True
            pos = qPos + 1
        End If
    Loop
    
End Function
Private Sub ProcessContentType(content,field)
    Dim n
    n = FindColonThroughQuotes(content,1)
    field("ContentType") = Trim(Left(content,n - 1))
End Sub
Private Function StripQuotes(str)
    If Left(str,1) = """" Or Left(str,1) = "'" Then
        StripQuotes = Mid(str,2,Len(str) - 2)
    Else
        StripQuotes = str
    End If
End Function
Private Sub ProcessContentDisposition(content,field)
    Dim n, cnt, cur, t
    cnt = content
    n = 0
    
    Do 
        n = FindColonThroughQuotes(cnt,1)
        cur = Trim(Left(cnt,n - 1))
        If cur = "" Then Exit Sub
        t = InStr(cur,"=")
        If t > 0 Then
            Select Case UCase(Left(cur,t - 1))
                Case "NAME"
                    field("Name") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                Case "FILENAME"
                    field("RawFileName") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                    field("FileName") = sf.GetFileName(field("RawFileName"))
                    field("FileNameExtension") = sf.GetExtensionName(field("RawFileName"))
                    field("IsFile") = True
            End Select
        End If
        cnt = Mid(cnt,n+1)
    Loop
End Sub
Private Sub ProcessHeader(line, field)
    Dim headName, n, headContent
    n = InStr(line,":")
    If n = 0 Then Err.Raise 2,"CUpload", "Invalid header: " & line
    headName = Trim(Left(line, n -1))
    headContent = Mid(line,n + 1, Len(line) - n)
    Select Case UCase(headName)
        Case "CONTENT-TYPE"
            ProcessContentType headContent, field
        Case "CONTENT-DISPOSITION"
            ProcessContentDisposition headContent, field
        Case Else
            field.Add headName, headContent
    End Select
End Sub
Private Sub BuildUploadRequest(ByVal postStream)
    ' Determine the boundary (it is the first line)
    Dim boundary, eolSequence, eolLength
    boundary = postStream.ReadText(-3)
    If boundary = "" Then Err.Raise 1, "CUpload", "Incorrect post encoding " & boundary
    ' Determine the end-of-line
    eolLength = postStream.Pos - Len(boundary)
    postStream.Pos = Len(boundary)
    eolSequence = postStream.ReadText(eolLength)
    postStream.textLineSeparator = eolSequence
      
    ' Loop through the fields
    Dim line ' The current line
    Dim nextLine ' The next line
    Dim field ' The current field
    Dim coll, temp
    Dim nHeaders
    Do
        ' Create a node holder for the element/field
        Set field = Post.CreateNew
        field.firstItemAsRoot = True
        field.Add "Value", Empty
        field("IsFile") = False
        ' Loop through the headers
        nHeaders = 0
        line = postStream.ReadText(-1)
        While line <> ""
            ' Read next line
            nextLine = postStream.ReadText(-1)
            ' The headers support hiphenation (not happens with IE but it is possible with other browsers)
            While Left(nextLine,1) = vbTab Or Left(nextLine,1) = " "
                line = line & nextLine
                nextLine = postStream.ReadText(-1)
            Wend
            ' Here we have the full line
            ProcessHeader line, field
            line = nextLine
            nHeaders = nHeaders + 1
        Wend
        If nHeaders = 0 Then
            Err.Raise 1, "CUpload", "A field without headers found in the post data or the post ended unexpectedly."
        End If
        ' Headers ended - the content follows
        ' Find the end
        field("ContentBegin") = postStream.Pos
        field("ContentEnd") = postStream.Find(boundary,2) - Len(boundary) - eolLength
        field("ContentLength") = field("ContentEnd") - field("ContentBegin")
        
        ' Set the value
        ' In this version we hold it as binary data (high memory consumption)
        If field("IsFile") Then
            temp = postStream.Pos
            postStream.Pos = field("ContentBegin")
            field("Value") = postStream.ReadBin(field("ContentLength"))
            postStream.Pos = temp
        Else
            temp = postStream.Pos
            postStream.Pos = field("ContentBegin")
            field("Value") = postStream.ReadText(field("ContentLength"))
            postStream.Pos = temp
        End IF
        
        If IsEmpty(Post(field("Name"))) Then
            Set coll = Post.CreateNew
            coll.firstItemAsRoot = True
            coll.allowUnnamedValues = True
            coll.Add "", field
            Post.Add field("Name"), coll
        Else
            Post(field("Name")).Add "", field
        End If
        
        line = postStream.ReadText(-1)
        If line = "--" Then
            ' This is end of the upload
            Exit Do
        End If            
    Loop
End Sub







    